From f307ccd458a2ffa1fb2f13561bd4fafa9cc16dcc Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:29 +0000
Subject: [PATCH 4/17] Group tests into subpackages.


  - This will enable us to run each test suite separately.

---

diff --git a/kiskadee/fetchers/example.py b/kiskadee/fetchers/example.py
index a4c1593..02eb9b2 100644
--- a/kiskadee/fetchers/example.py
+++ b/kiskadee/fetchers/example.py
@@ -9,8 +9,7 @@ class Fetcher(kiskadee.fetchers.Fetcher):
         """Use sources from test suite."""
         return 'kiskadee/tests/test_source/test_source.tar.gz'
 
-    @kiskadee.queue.enqueue_project
-    def watch(self):
+    def watch(self, **kwargs):
         """There is no proper API to inspect new example versions.
         It should not matter, since example will not receive updates.
         """
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index fbf68bc..ef3fb77 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -53,32 +53,9 @@ class Monitor:
             if pkg:
                 self._send_to_runner(pkg)
             time.sleep(2)
-            analyzed_project = self.queues.dequeue_result()
+            analyzed_project = self.kiskadee_queue.dequeue_result()
             self._save_analyzed_project(analyzed_project)
 
-    def dequeue_package(self):
-        """Dequeue packages from packages_queue."""
-        if not kiskadee.queue.packages_queue.empty():
-            pkg = kiskadee.queue.packages_queue.get()
-            kiskadee.logger.debug(
-                    "MONITOR: Dequed Package: {}_{}"
-                    .format(pkg["name"], pkg["version"])
-                )
-            return pkg
-        return {}
-
-    # Use directly dequeue_result from kiskadee.queue
-    #def dequeue_result(self):
-    #    """Dequeue analyzed packages from result_queue."""
-    #    if not self.kiskadee_queue.results_empty():
-    #        pkg = self.kiskadee_queue.dequeue_result()
-    #        kiskadee.logger.debug(
-    #                "MONITOR: Dequed result for package : {}-{}"
-    #                .format(pkg["name"], pkg["version"])
-    #            )
-    #        return pkg
-    #    return {}
-
     def _send_to_runner(self, pkg):
         _name = pkg['fetcher'].split('.')[-1]
         _fetcher = self._query(Fetcher).filter_by(name = _name).first()
@@ -103,8 +80,8 @@ class Monitor:
                     self.kiskadee_queue.enqueue_analysis(pkg)
 
     # Move this to model.py
-    def _save_analyzed_project(self, project):
-        if not pkg:
+    def _save_analyzed_project(self, data):
+        if not data:
             return {}
         project = self._query(Package).filter_by(name = data['name']).first()
         if not project:
@@ -116,7 +93,7 @@ class Monitor:
             self._save_analysis(data, analyzer, result, project.versions[-1])
 
     # Move this to model.py
-    def _update_pkg(self, package, pkg):
+    def _update_project(self, package, pkg):
 
         if(package.versions[-1].number == pkg['version']):
             return package
@@ -138,7 +115,7 @@ class Monitor:
             return None
 
     # Move this to model.py
-    def _save_pkg(self, pkg):
+    def _save_project(self, pkg):
         homepage = None
         if ('meta' in pkg) and ('homepage' in pkg['meta']):
             homepage = pkg['meta']['homepage']
@@ -253,11 +230,11 @@ def daemon():
     runner = Runner()
     monitor_process = Process(
             target=monitor.monitor,
-            args=(queues)
+            args=(queues,)
         )
     runner_process = Process(
             target=runner.runner,
-            args=(queues)
+            args=(queues,)
         )
     monitor_process.start()
     runner_process.start()
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index a6835ea..214b631 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -1,5 +1,6 @@
 """Provide kiskadee queues and operations on them."""
 import time
+import dill
 from multiprocessing import Queue
 
 import kiskadee
@@ -23,10 +24,10 @@ def enqueue_project(fetcher_watch):
     """
     def wrapper(*args, **kwargs):
         project = fetcher_watch(*args, **kwargs)
-        kiskadee.queue.Queues.enqueue_project(project)
+        kiskadee.queue.queues.enqueue_project(project)
         fetcher = project['fetcher'].name
         kiskadee.logger.debug(
-                "{} fetcher: Sending package {}_{} for monitor"
+                "{} fetcher: sending package {}_{} for monitor"
                 .format(fetcher, package['name'], package['version'])
             )
         time.sleep(2)
@@ -40,15 +41,14 @@ class Queues():
     """Provide kiskadee queues objects."""
 
     @staticmethod
-    def enqueue_analysis(analysis):
+    def enqueue_analysis(project_to_analysis):
         """Put a analysis on the analysis queue."""
-        analysis.put(analysis)
+        analysis.put(project_to_analysis)
 
     @staticmethod
-    @empty_queue
     def dequeue_analysis():
         """Get a analysis from the analysis queue."""
-        return analysis.get(timeout=1)
+        return analysis.get()
 
     @staticmethod
     def enqueue_result(result):
diff --git a/kiskadee/tests/api/test_api.py b/kiskadee/tests/api/test_api.py
index 0b83d1a..e88fee5 100644
--- a/kiskadee/tests/api/test_api.py
+++ b/kiskadee/tests/api/test_api.py
@@ -1,10 +1,8 @@
 import json
 import unittest
-from sqlalchemy.orm import sessionmaker
 from unittest.mock import MagicMock
 
 import kiskadee
-from kiskadee.runner import Runner
 from kiskadee.monitor import Monitor
 import kiskadee.api.app
 import kiskadee.fetchers.example
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index aa95be6..67cd7c2 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -3,8 +3,8 @@ from sqlalchemy.orm import sessionmaker
 
 from kiskadee import model
 from kiskadee.monitor import Monitor
-from kiskadee.queue import packages_queue
-from kiskadee.model import Package, Fetcher, create_analyzers, Report, Analysis
+from kiskadee.queue import Queues
+from kiskadee.model import Package, create_analyzers, Report, Analysis
 import kiskadee.queue
 import kiskadee.fetchers.debian
 import kiskadee.fetchers.anitya
@@ -18,12 +18,13 @@ class MonitorTestCase(unittest.TestCase):
         Session = sessionmaker(bind=self.engine)
         self.session = Session()
         self.monitor = Monitor(self.session)
+        self.queues = Queues()
         model.Base.metadata.create_all(self.engine)
         create_analyzers(self.session)
         self.pkg1 = {
                 'name': 'curl',
                 'version': '7.52.1-5',
-                'fetcher': kiskadee.fetchers.debian,
+                'fetcher': kiskadee.fetchers.debian.__name__,
                 'meta': {'directory': 'pool/main/c/curl'},
                 'results': {
                     'cppcheck': '<>',
@@ -32,7 +33,7 @@ class MonitorTestCase(unittest.TestCase):
 
         self.pkg2 = {'name': 'urlscan',
                      'version': '0.8.2',
-                     'fetcher': kiskadee.fetchers.debian,
+                     'fetcher': kiskadee.fetchers.debian.__name__,
                      'meta': {'directory': 'pool/main/u/urlscan'},
                      'results': {
                             'cppcheck': '<>',
@@ -41,7 +42,7 @@ class MonitorTestCase(unittest.TestCase):
 
         self.pkg3 = {'name': 'curl',
                      'version': '7.52.2-5',
-                     'fetcher': kiskadee.fetchers.debian,
+                     'fetcher': kiskadee.fetchers.debian.__name__,
                      'meta': {'directory': 'pool/main/c/curl'},
                      'results': {
                             'cppcheck': '<>',
@@ -49,7 +50,7 @@ class MonitorTestCase(unittest.TestCase):
                      'fetcher_id': 1}
         self.pkg4 = {'name': 'urlanitya',
                      'version': '0.11',
-                     'fetcher': kiskadee.fetchers.anitya,
+                     'fetcher': kiskadee.fetchers.anitya.__name__,
                      'meta': {
                             'backend': 'gitHub',
                             'homepage': 'https://github.com/GesielFreitas/Cros'
@@ -78,31 +79,14 @@ class MonitorTestCase(unittest.TestCase):
         fetcher = kiskadee.fetchers.debian.Fetcher()
         self.assertEqual(fetcher.name, 'debian')
 
-    def test_save_some_fetcher(self):
-        fetcher = kiskadee.fetchers.debian.Fetcher()
-        self.monitor._save_fetcher(fetcher)
-        _fetchers = self.monitor.session.query(Fetcher).all()
-        self.assertEqual(len(_fetchers), 1)
-        self.assertEqual(_fetchers[0].name, 'debian')
-        self.assertEqual(_fetchers[0].description,
-                         fetcher.config['description'])
-
     def test_save_package(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        packages_queue.put(self.pkg1)
-        packages_queue.put(self.pkg2)
-
-        _pkg = self.monitor.dequeue_package()
-        self.monitor._save_analyzed_pkg(_pkg)
-        _pkgs = self.monitor.session.query(Package).all()
-        self.assertEqual(len(_pkgs), 1)
-        self.assertEqual(_pkgs[0].name, _pkg['name'])
-
-        _pkg = self.monitor.dequeue_package()
-        self.monitor._save_analyzed_pkg(_pkg)
+        self.monitor._save_analyzed_project(self.pkg1)
+        self.monitor._save_analyzed_project(self.pkg2)
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 2)
-        self.assertEqual(_pkgs[1].name, _pkg['name'])
+        self.assertEqual(_pkgs[0].name, self.pkg1['name'])
+        self.assertEqual(_pkgs[1].name, self.pkg2['name'])
 
     def test_save_reports(self):
         _fetcher = model.Fetcher(
@@ -142,21 +126,21 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_version(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        self.monitor._save_analyzed_pkg(self.pkg1)
+        self.monitor._save_analyzed_project(self.pkg1)
         _pkgs = self.monitor.session.query(Package).all()
         _version = _pkgs[0].versions[0].number
         self.assertEqual(_version, self.pkg1['version'])
 
     def test_update_version(self):
         self.monitor._save_fetcher(kiskadee.fetchers.debian.Fetcher())
-        packages_queue.put(self.pkg1)
-        packages_queue.put(self.pkg3)
+        self.queues.enqueue_project(self.pkg1)
+        self.queues.enqueue_project(self.pkg3)
 
-        _pkg = self.monitor.dequeue_package()
-        self.monitor._save_analyzed_pkg(_pkg)
+        _pkg = self.queues.dequeue_project()
+        self.monitor._save_analyzed_project(_pkg)
 
-        _pkg = self.monitor.dequeue_package()
-        self.monitor._save_analyzed_pkg(_pkg)
+        _pkg = self.queues.dequeue_project()
+        self.monitor._save_analyzed_project(_pkg)
 
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
@@ -171,11 +155,9 @@ class MonitorTestCase(unittest.TestCase):
 
     def test_save_package_anitya(self):
         self.monitor._save_fetcher(kiskadee.fetchers.anitya.Fetcher())
-        packages_queue.put(self.pkg4)
-
-        _pkg = self.monitor.dequeue_package()
-        self.monitor._save_analyzed_pkg(_pkg)
-
+        self.queues.enqueue_project(self.pkg4)
+        _pkg = self.queues.dequeue_project()
+        self.monitor._save_analyzed_project(_pkg)
         _pkgs = self.monitor.session.query(Package).all()
         self.assertEqual(len(_pkgs), 1)
         self.assertEqual(_pkgs[0].homepage, _pkg['meta']['homepage'])
diff --git a/kiskadee/tests/integration/test_runner.py b/kiskadee/tests/integration/test_runner.py
index 0ad1e0a..f9a2e16 100644
--- a/kiskadee/tests/integration/test_runner.py
+++ b/kiskadee/tests/integration/test_runner.py
@@ -1,3 +1,8 @@
+"""
+This integration tests needs docker engine be running and accessible
+by the user that is executing the tests. It also needs selinux running in
+a permissive mode (setenforce 0)
+"""
 import unittest
 import tempfile
 
@@ -6,12 +11,11 @@ import kiskadee.fetchers.example
 import kiskadee.fetchers.debian
 from sqlalchemy.orm import sessionmaker
 from kiskadee import model
-from kiskadee.queue import KiskadeeQueue
+from kiskadee.queue import Queues
 from kiskadee.database import Database
 
 
 class AnalyzersTestCase(unittest.TestCase):
-
     def setUp(self):
         self.engine = Database('db_test').engine
         Session = sessionmaker(bind=self.engine)
@@ -21,16 +25,15 @@ class AnalyzersTestCase(unittest.TestCase):
         self.fetcher = kiskadee.fetchers.debian.Fetcher()
         self.deb_pkg = {'name': 'test',
                         'version': '1.0.0',
-                        'fetcher': kiskadee.fetchers.debian.Fetcher()
+                        'fetcher': kiskadee.fetchers.debian.__name__
                         }
         self.fetcher = model.Fetcher(
                 name='kiskadee-fetcher2', target='university'
             )
         self.session.add(self.fetcher)
         self.session.commit()
-        kiskadee_queue = KiskadeeQueue()
         self.runner = Runner()
-        self.runner.kiskadee_queue = kiskadee_queue
+        self.runner.queues = Queues()
 
     def tearDown(self):
         self.session.close()
@@ -54,12 +57,11 @@ class AnalyzersTestCase(unittest.TestCase):
         source_to_analysis = {
                 'name': 'test',
                 'version': '1.0.0',
-                'fetcher': kiskadee.fetchers.example.Fetcher()
+                'fetcher': kiskadee.fetchers.example.__name__
         }
 
         self.runner.call_analyzers(source_to_analysis)
-        analyzed_pkg = self.runner.kiskadee_queue.dequeue_result()
-
+        analyzed_pkg = self.runner.queues.dequeue_result()
         self.assertEqual(analyzed_pkg['name'], source_to_analysis['name'])
         self.assertIn('cppcheck', analyzed_pkg['results'])
         self.assertIn('flawfinder', analyzed_pkg['results'])
@@ -93,5 +95,6 @@ class AnalyzersTestCase(unittest.TestCase):
 
         self.assertIsNone(source_path)
 
+
 if __name__ == '__main__':
     unittest.main()
diff --git a/kiskadee/tests/plugins/test_plugins.py b/kiskadee/tests/plugins/test_plugins.py
index 030da9a..9fe8262 100644
--- a/kiskadee/tests/plugins/test_plugins.py
+++ b/kiskadee/tests/plugins/test_plugins.py
@@ -70,7 +70,7 @@ class DebianFetcherTestCase(unittest.TestCase):
         self.debian_fetcher._queue_sources_gz_pkgs(temp_dir)
         shutil.rmtree(temp_dir)
 
-        some_pkg = kiskadee.queue.packages_queue.get()
+        some_pkg = kiskadee.queue.Queues.dequeue_project()
         self.assertTrue(isinstance(some_pkg, dict))
         self.assertIn('name', some_pkg)
         self.assertIn('version', some_pkg)
@@ -190,8 +190,8 @@ class TestAnityaFetcher(unittest.TestCase):
 
     def test_create_package_dict(self):
 
-        self.anitya_fetcher._create_package_dict(self.msg)
-        _dict = kiskadee.queue.packages_queue.get()
+        self.anitya_fetcher.project_to_enqueue(self.msg)
+        _dict = kiskadee.queue.Queues().dequeue_project()
         self.assertEqual(_dict['name'], 'urlscan')
         self.assertEqual(_dict['version'], '0.8.5')
         self.assertEqual(_dict['meta']['backend'], 'GitHub')
@@ -199,7 +199,7 @@ class TestAnityaFetcher(unittest.TestCase):
                 _dict['meta']['homepage'],
                 'https://github.com/firecat53/urlscan'
         )
-        self.assertEqual(_dict['fetcher'].name, 'anitya')
+        self.assertEqual(_dict['fetcher'], 'kiskadee.fetchers.anitya')
 
 
 if __name__ == '__main__':
